
//-------------------------------------------------<       >----------------------------------------------------
//-------------------------------------------------<                                           >----------------------------------------------------
//-------------------------------------------------<   2015 http://www.avrki.ru >----------------------------------------------------

#ifndef CICLE_BUFFER_H_
#define CICLE_BUFFER_H_

//-------------------------------------------------------------------------
//				     !
//				0, 1, 2, 4, 8, 16, 32, 64, 128, 256
//				     128 
//-------------------------------------------------------------------------

#define BUFFER_SIZE 128U											
#define BUFFER_MASK (BUFFER_SIZE-1)
#define BUFFER_TIME 15

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------

volatile BYTE IndexIN, IndexOUT;
volatile BYTE buffer[BUFFER_SIZE];
volatile BYTE uart_flag = 0;

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

#include <avr/io.h>
#include <avr/interrupt.h>
#include <axlib/type_var.h>
#include <axlib/usart.h>


//-------------------------------------------------------------------------
//					  USART   
//-------------------------------------------------------------------------

ISR(USART_RX_vect)
{
	uart_flag = 1;
	InBuffer(UDR0);
}

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------

void ClearBuffer(void)
{
	cli();
	IndexIN = 0;
	IndexOUT = 0;
	sei();
}

//-------------------------------------------------------------------------
//			      
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
//	  :
//
//		BYTE -        
//					    .
//	
//-------------------------------------------------------------------------

BYTE IndexNumber(void)
{
	if (IndexIN >= IndexOUT)
	{
		return (IndexIN - IndexOUT);
	}
	else
	{
		return ((BUFFER_SIZE - IndexOUT) + IndexIN);
	}
}

//-------------------------------------------------------------------------
//					     
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
//	 :
//
//		BYTE value -   ,  
//							  .   
//							  .
//
//	 :
//
//		BYTE -     .
//					  : BUFFER_OK -   
//							BUFFER_OVERFLOW -  
//	
//-------------------------------------------------------------------------

void InBuffer(BYTE val)
{
	IndexIN++;
	IndexIN &= BUFFER_MASK;
	buffer[IndexIN] = val;
}

//-------------------------------------------------------------------------
//					     
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
//	 :
//
//		BYTE *str -       
//						          .
//
//		BYTE lenght -       .
//
//	          
//	.
//
//-------------------------------------------------------------------------

BYTE OutBufferStr(BYTE *str, BYTE lenght)
{
	for(BYTE i=0; i<lenght; i++)
	{
		IndexOUT++;
		IndexOUT &= BUFFER_MASK;
		*str = buffer[IndexOUT];
		str++;
	}
	uart_flag = 0;
	
	return lenght;
}

//-------------------------------------------------------------------------
//				      
//				  ,   0
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//
//	 :
//
//		BYTE -     .
//					  : 0				-  
//							  -      
//
//-------------------------------------------------------------------------

BYTE GetData(void)
{
	if(IndexIN != IndexOUT)
	{
		return IndexNumber();
	}
	return 0;
}

//-------------------------------------------------------------------------	


#endif /* CICLE_BUFFER_H_ */