
//-------------------------------------------------<                      axlib v1.1                       >----------------------------------------------------
//-------------------------------------------------<        DFP-2106 >----------------------------------------------------
//-------------------------------------------------<         2015 http://www.avrki.ru       >----------------------------------------------------


#ifndef PSENSOR_VAZ_H_
#define PSENSOR_VAZ_H_

#if !defined(MAIN_INIT_H_)
#error "You must included (#include \"main_init.h\") befor use (#include <axlib/psensor_vaz.h>)."
#endif

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

#include <avr/io.h>
#include <axlib/type_var.h>
#include <axlib/adc.h>

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

volatile WORD r_senser = 300;	//    
volatile WORD r_2 = 22;			//   
volatile ADATA p_max = 8;		//  
volatile ADATA u_input = 5;		//   
volatile ADATA k_adc = 0.004882;
volatile ADATA k_up	= 110;
volatile ADATA k_p = 0.02667;

//-------------------------------------------------------------------------
//	  .
//
//	 :
//
//		BYTE inref -/  
//-------------------------------------------------------------------------

void p_sensor_vaz_init(void)
{
	adc_init(u_input, ADC_IREF_OFF);
}

//-------------------------------------------------------------------------
//	  .
//
//	 :
//
//		WORD rs -      
//		WORD r2	-     
//		ADATA pmax -    /
//		ADATA u_in -     
//		BYTE inref -/  
//-------------------------------------------------------------------------

void p_sensor_vaz_init_data(WORD rs, WORD r2, ADATA pmax, ADATA u_in, BYTE inref)
{
	r_senser = rs;
	r_2 = r2;
	
	k_up = u_in*r2;
	k_adc = u_in/1024;
	k_p = pmax/rs;
	
	adc_init(u_in, inref);
}

//-------------------------------------------------------------------------
//	   .
//
//  :
//
//		BYTE adc_ch -       
//
//      float
//-------------------------------------------------------------------------

ADATA press_vaz(BYTE adc_ch)
{
	WORD adc = adc_data(adc_ch);
		
	return ((r_senser-(k_up/(adc*k_adc)-r_2))*k_p);
}

#endif /* PSENSOR_VAZ_H_ */